function [f,g] = autoGrad(x,funObj,varargin)
% Numerically compute gradient of objective function from function values

p = length(x);

% Use Central-Differencing Formula
mu = 2*sqrt(1e-12)*(1+norm(x));
f1 = zeros(p,1);
f2 = zeros(p,1);
for j = 1:p
    e_j = zeros(p,1);
    e_j(j) = 1;
    f1(j,1) = funObj(x + mu*e_j,varargin{:});
    f2(j,1) = funObj(x - mu*e_j,varargin{:});
end
f = mean([f1;f2]);
g = (f1 - f2)/(2*mu);